Drop unused condition check
[pcp.git] / qa / 066
blob81d590e98e832d5c8dac9a95fa30844c436b8ebe
1 #! /bin/sh
2 # PCP QA Test No. 066
3 # Test PMCD correctly restores original access control list after
4 # reconfiguration with a bad config file.
6 # Copyright (c) 1995-2002 Silicon Graphics, Inc. All Rights Reserved.
9 seq=`basename $0`
10 echo "QA output created by $seq"
12 # get standard filters
13 . ./common.product
14 . ./common.filter
15 . ./common.check
17 rm -f $seq.out
18 _get_libpcp_config
19 if $ipv6 ; then
20 ln $seq.out.ipv6 $seq.out || exit 1
21 else
22 ln $seq.out.nonipv6 $seq.out || exit 1
25 trap "rm -f $tmp $tmp.*; exit" 0 1 2 3 15
26 rm -f $seq.full
28 # real QA test starts here
30 signal=$PCP_BINADM_DIR/pmsignal
31 log=$PCP_PMCDLOG_PATH
32 _needclean=true
33 LOCALHOST=`hostname`
35 _filter_log()
37 sleep 1
38 _filter_pmcd_log <$log \
39 | grep -v "^access violation from host" \
40 | grep -v "^endclient client" \
41 | sed \
42 -e 's/^$//' \
43 -e '/^00[08]:/d' \
44 -e '/^linux/s/\/var\//\/usr\//' \
45 -e '/^sample/s/.*/sample agent.../' \
46 -e 's;pcp/lib/mips_[^.]*\.;pcp/lib/ISA.;' \
47 -e '/client connection from/,/^$/d' \
48 -e 's/1 dso/X dso/' \
49 -e 's/2 dso/X dso/' \
50 -e 's/00001983 0000ffff/83190000 ffff0000/' \
51 -e "s;$PCP_PMCDCONF_PATH;\$PCP_PMCDCONF_PATH;g" \
52 -e "s;$PCP_VAR_DIR;\$PCP_VAR_DIR;g" \
53 -e 's;$PCP_PMDAS_DIR/pmcd/;;' \
54 -e "s;\.$DSO_SUFFIX;.\$DSO_SUFFIX;g" \
55 -e '/UNIX_DOMAIN_SOCKET/d' \
56 -e '/unix:/d' \
57 | $PCP_AWK_PROG '
58 /localhost/ { sub(/^[0-9][0-9]*\.[0-9][0-9]*\.[0-9][0-9]*\.[0-9][0-9]*$/,"MYIPADDR",$5)
59 sub(/^[0-9a-f:][0-9a-f:]*%[0-9a-z]+$/,"MYIPADDR",$5)
60 sub(/^[0-9a-f:][0-9a-f:]*$/,"MYIPADDR",$5)
61 sub(/^[0-9][0-9]*\.[0-9][0-9]*\.[0-9][0-9]*\.[0-9][0-9]*$/,"MYHOSTMASK",$6)
62 sub(/^[0-9a-f:][0-9a-f:]*$/,"MYHOSTMASK",$6) }
63 { print }'
66 interrupt()
68 echo "Interrupted"
69 exit
72 if [ -d $PCP_LOG_DIR/pmlogger ]
73 then
74 LOGGING_DIR=$PCP_LOG_DIR/pmlogger
75 else
76 LOGGING_DIR=$PCP_LOG_DIR
79 cleanup()
81 if [ $_needclean ]
82 then
83 $sudo $PCP_RC_DIR/pcp stop | _filter_pcp_stop
84 _restore_config $PCP_PMCDCONF_PATH
85 pmafm $LOGGING_DIR/$LOCALHOST/Latest remove >$tmp.cmd 2>&1 \
86 && $sudo sh $tmp.cmd
87 echo "Restarting pmcd"
88 echo "+++ restarting pmcd `date` +++" >>$seq.full
89 $sudo $PCP_RC_DIR/pcp restart | tee -a $seq.full | _filter_pcp_start
90 _wait_for_pmcd
91 _wait_for_pmlogger
92 _needclean=false
94 rm -f $tmp $tmp.*
97 _myfilter_config()
99 sed \
100 -e "s/$other1/OTHER1/" \
101 -e "s/$other2/OTHER2/" \
102 -e "s;$PCP_RC_DIR;\$PCP_RC_DIR;g" \
103 -e "s;$PCP_PMDAS_DIR;\$PCP_PMDAS_DIR;g" \
104 -e "/^linux/s/.*/[platform PMDA]/" \
105 -e "/^darwin/s/.*/[platform PMDA]/" \
106 -e "/^solaris/s/.*/[platform PMDA]/" \
107 -e 's;$PCP_PMDAS_DIR/pmcd/;;' \
108 -e "s;\.$DSO_SUFFIX;.\$DSO_SUFFIX;g" \
109 | _filter_pmcd_log
112 pmafm $LOGGING_DIR/$LOCALHOST/Latest remove >$tmp.cmd 2>&1 \
113 && $sudo sh $tmp.cmd
115 trap "interrupt; cleanup; exit" 1 2 3 15
116 trap "cleanup; exit" 0
118 cat >$tmp <<End-of-File
119 # need the pmcd PMDA so that "init" restart can start pmlogger
120 # the OS PMDA has to be there so that the default logging config works
121 # created by QA 066
123 End-of-File
125 if [ $PCP_PLATFORM = linux ]
126 then
127 cat >>$tmp <<End-of-File
128 linux 60 dso linux_init $PCP_PMDAS_DIR/linux/pmda_linux.so
129 pmcd 2 dso pmcd_init $PCP_PMDAS_DIR/pmcd/pmda_pmcd.so
130 End-of-File
131 elif [ $PCP_PLATFORM = darwin ]
132 then
133 cat >>$tmp <<End-of-File
134 darwin 78 dso darwin_init $PCP_PMDAS_DIR/darwin/pmda_darwin.dylib
135 pmcd 2 dso pmcd_init $PCP_PMDAS_DIR/pmcd/pmda_pmcd.dylib
136 End-of-File
137 elif [ $PCP_PLATFORM = solaris ]
138 then
139 cat >>$tmp <<End-of-File
140 solaris 75 dso solaris_init $PCP_PMDAS_DIR/solaris/pmda_solaris.so
141 pmcd 2 dso pmcd_init $PCP_PMDAS_DIR/pmcd/pmda_pmcd.so
142 End-of-File
143 else
144 echo "Error - need pmcd.conf setup for PCP_PLATFORM $PCP_PLATFORM"
145 exit 1
148 cat >>$tmp <<End-of-File
150 [access]
151 allow localhost: all;
152 disallow 131.25.*: store;
153 disallow *: all;
155 End-of-File
157 eval `./getpmcdhosts -L -n 2 \
158 | $PCP_AWK_PROG '{ if (NF == 2) printf("other1=%s other2=%s\n",$1,$2); }'`
160 if [ -z "$other1" -o -z "$other2" ]
161 then
162 echo "Cannot find two remote hosts running pmcd" >$seq.notrun
163 status=1
164 exit
167 _save_config $PCP_PMCDCONF_PATH
168 echo "+++ stopping pmcd `date` +++" >>$seq.full
169 $sudo $PCP_RC_DIR/pcp stop | tee -a $seq.full | _filter_pcp_stop
170 $sudo $signal -a pmgadgets pmchart pmview >/dev/null 2>&1
171 $sudo cp $tmp $PCP_PMCDCONF_PATH
172 # try to dodge bind: Address already in use
173 [ $PCP_PLATFORM = solaris ] && sleep 10
174 echo "+++ starting pmcd `date` +++" >>$seq.full
175 $sudo $PCP_RC_DIR/pcp start | tee -a $seq.full | _filter_pcp_start
176 echo "first config:"
177 _myfilter_config <$PCP_PMCDCONF_PATH
178 echo
180 cat >>$tmp <<End-of-File
182 disallow $other1: store;
183 allow $other2: all;
185 ddiissallow misspelt: all;
186 End-of-File
188 $sudo cp $tmp $PCP_PMCDCONF_PATH
189 echo "second config:"
190 _myfilter_config <$PCP_PMCDCONF_PATH
192 echo
193 $sudo $signal -a -s HUP pmcd
194 _wait_for_pmcd
196 # wait for PMCD to finish writing log (or 5 seconds)
197 for t in 1 2 3 4 5
199 if [ ! -f $log ]
200 then
201 echo "$log missing!"
202 ls -l `dirname $log`
203 cat ${log}.prev >>$seq.full
204 exit
205 elif [ `egrep '^Host access' $log | wc -l` = 2 ]
206 then
207 break
209 sleep 1
210 done
212 _filter_log